unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
	Timer1: TTimer;
	procedure FormCreate(Sender: TObject);
	procedure Timer1Timer(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure FormPaint(Sender: TObject);
  private
	{ Private declarations }
  public
	procedure DrawCharacter(x, y: integer; xOld, yOld: integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
	math;

type
	TVector = record
		x, y: double;
	end;
const
	MOVE_STEP = 10;
	QAZ = MOVE_STEP div 2;
var
	g_pos: TVector = (x: 30; y:30);
	g_dest: TVector;
	g_vector: TVector;
	g_angle: double = 0.0;
	g_chara: TBitmap;

procedure TForm1.FormCreate(Sender: TObject);
begin
	Canvas.Brush.Color := RGB(0, 0, 255);
	Timer1.Interval := 100;
	Timer1.Enabled := FALSE;

	g_chara := TBitmap.Create();
	g_chara.LoadFromFile('./chara.bmp');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	g_chara.Free();
end;

procedure TForm1.DrawCharacter(x, y: integer; xOld, yOld: integer);
const
	c_step: integer = 0;
var
	direction: integer;
	angle: double;
begin
	angle := g_angle * 180 / PI;
	if angle < 0.0 then
		angle := angle + 360.0;

	c_step := c_step xor $01;

	if angle < 90.0 then
		direction := 1
	else if angle < 180.0 then
		direction := 0
	else if angle < 270.0 then
		direction := 2
	else
		direction := 3;

	Canvas.FillRect(Bounds(xOld - 54 div 2, yOld - 60, 54, 70));
	Canvas.CopyRect(Bounds(x - 54 div 2, y - 60, 54, 70), g_chara.Canvas, Bounds(1+55*c_step,1+direction*71,54,70));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
	xOld, yOld: integer;
begin
	xOld := round(g_pos.x);
	yOld := round(g_pos.y);

	g_pos.x := g_pos.x + g_vector.x;
	g_pos.y := g_pos.y + g_vector.y;
	if (abs(g_pos.x - g_dest.x) < QAZ) and (abs(g_pos.y - g_dest.y) < QAZ) then begin
		g_pos := g_dest;
		Timer1.Enabled := FALSE;
	end;

	DrawCharacter(round(g_pos.x), round(g_pos.y), xOld, yOld);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
	g_angle  := arctan2(y - g_pos.y, x - g_pos.x);
	g_dest.x := x;
	g_dest.y := y;
	g_vector.x := MOVE_STEP * cos(g_angle);
	g_vector.y := MOVE_STEP * sin(g_angle);
	timer1.Enabled := TRUE;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
	Canvas.FillRect(Canvas.ClipRect);
end;

end.
